# CODING OA UIkit 

### Change Log

[CHANGELOG](./CHANGELOG.md)

### Building and running on localhost

First install dependencies:

```sh
yarn install
```

To run in hot module reloading mode:

```sh
yarn doc
```

To create a production build:

```sh
yarn run build-prod
```

To create a development build:

```sh
yarn run build-dev
```

### Project Structure

```
.
├── common            ~> 业务无关的公共代码
├── components        ~> uikit 组件
├── style-dictionary  ~> 管理 design token
├── styleguide        ~> 修改或覆盖的 styleguide 组件和样式
│   └── ...
├── pages             ~> uikit 网站页面
│   ├── design        ~> 设计文档
│   └── ...
└── lib               ~> 业务相关的公共代码
    └── ...
└── script            ~> 发布和资源整理等脚本
└── ...
```

### Contribution guide

[CONTRIBUTION](./CONTRIBUTION.md)
