"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-a11y/click-events-have-key-events */
var react_1 = __importDefault(require("react"));
var camelCase_1 = __importDefault(require("lodash/camelCase"));
var kebabCase_1 = __importDefault(require("lodash/kebabCase"));
var classnames_1 = __importDefault(require("classnames"));
var uuid_1 = __importDefault(require("uuid"));
var portal_1 = __importDefault(require("../portal"));
var helper_1 = require("../helper");
var motion_1 = __importStar(require("../motion"));
var datasetKey = 'current-cuk-dialog';
var dialogs = [];
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog(props) {
        var _this = _super.call(this, props) || this;
        _this.bodyStyle = {
            origin: {},
            locked: {},
        };
        _this.id = uuid_1.default();
        _this.outer = '';
        _this.inited = false;
        _this.hideByOtherDialog = false;
        _this.statusQueue = [];
        _this.initBodyStyle = function () {
            var body = document.body;
            if (!_this.outer && _this.getCurrentContainer() === body) {
                _this.bodyStyle.origin.overflow = body.style.overflow;
                _this.bodyStyle.locked.overflow = 'hidden';
                var scrollBarWidth = window.innerWidth - body.getBoundingClientRect().width;
                if (scrollBarWidth) {
                    _this.bodyStyle.origin.marginRight = body.style.marginRight;
                    _this.bodyStyle.origin.width = body.style.width;
                    _this.bodyStyle.locked.marginRight = scrollBarWidth + "px";
                    _this.bodyStyle.locked.width = "calc(100vw - " + scrollBarWidth + "px)";
                }
            }
        };
        _this.initEvent = function () {
            if (_this.props.escCloseable) {
                document.addEventListener('keydown', _this.handleKeyDown);
            }
        };
        _this.setOuter = function (outer) {
            _this.outer = outer === undefined ? document.body.dataset[camelCase_1.default(datasetKey)] || '' : outer;
        };
        _this.getCurrentContainer = function () {
            var getContainer = _this.props.getContainer;
            if (typeof getContainer === 'function') {
                return getContainer();
            }
            return undefined;
        };
        _this.needHideOuterModal = function () {
            if (_this.outer) {
                var outer = dialogs.find(function (dialog) { return dialog.id === _this.outer; });
                if (outer && outer.getCurrentContainer() === _this.getCurrentContainer()) {
                    outer.hide();
                }
            }
        };
        _this.needShowOuterModal = function () {
            if (_this.outer) {
                var outer = dialogs.find(function (dialog) { return dialog.id === _this.outer; });
                if (outer && outer.getCurrentContainer() === _this.getCurrentContainer()) {
                    outer.show();
                }
            }
        };
        _this.init = function () {
            _this.inited = true;
            _this.setOuter();
            _this.initBodyStyle();
            _this.initEvent();
            dialogs.push(_this);
        };
        _this.hide = function () {
            _this.hideByOtherDialog = true;
            _this.setState({ visible: false });
        };
        _this.show = function () {
            _this.hideByOtherDialog = false;
            _this.setState({ visible: true });
        };
        _this.clearEvent = function () {
            if (_this.props.escCloseable) {
                document.removeEventListener('keydown', _this.handleKeyDown);
            }
        };
        _this.setCurrentOpenModal = function (id) {
            if (!id) {
                document.body.removeAttribute("data-" + datasetKey);
            }
            else {
                document.body.setAttribute("data-" + datasetKey, "" + id);
            }
        };
        _this.switchVisible = function (visible) {
            if (visible) {
                _this.setState({ visible: true }, function () {
                    _this.setOuter();
                    _this.needHideOuterModal();
                    _this.toggleBodyLock(true);
                });
            }
            else {
                _this.close();
            }
        };
        _this.toggleBodyLock = function (lock) {
            var body = document.body;
            _this.setCurrentOpenModal(lock ? _this.id : _this.outer);
            if (_this.getCurrentContainer() !== body || _this.outer) {
                return;
            }
            if (lock) {
                Object.keys(_this.bodyStyle.locked).forEach(function (key) {
                    body.style[key] = _this.bodyStyle.locked[key];
                });
            }
            else {
                Object.keys(_this.bodyStyle.locked).forEach(function (key) {
                    var value = _this.bodyStyle.origin[key];
                    if (value) {
                        body.style[key] = value;
                    }
                    else {
                        body.style.removeProperty(kebabCase_1.default(key));
                    }
                });
            }
        };
        _this.handlePortalRendered = function () {
            _this.setState({ elementReady: true });
        };
        _this.close = function () {
            _this.hideByOtherDialog = false;
            _this.setState({ visible: false });
            _this.needShowOuterModal();
        };
        _this.handleMaskClick = function () {
            if (_this.props.maskCloseable) {
                _this.close();
            }
        };
        _this.handleKeyDown = function (e) {
            var currentOpenDialog = document.body.dataset[camelCase_1.default(datasetKey)];
            if (_this.state.visible &&
                _this.props.escCloseable &&
                currentOpenDialog === _this.id &&
                e.keyCode === 27) {
                _this.close();
            }
        };
        // 把状态变化放到一个队列里面保证每一个状态都一定能生效，不会因为两个状态之间的时间间隔太短被react合并成一个状态更新。
        _this.setStatus = function (status) {
            if (status) {
                _this.statusQueue.push(status);
            }
            var currentStatus = _this.statusQueue[0];
            _this.setState({ status: currentStatus }, function () {
                _this.statusQueue.shift();
                if (_this.statusQueue.length) {
                    _this.setStatus();
                }
            });
        };
        _this.handleStatusChange = function (status) {
            _this.setStatus(status);
        };
        _this.handleLeaveEnd = function () {
            var onClose = _this.props.onClose;
            if (!_this.hideByOtherDialog) {
                _this.toggleBodyLock(false);
                if (onClose) {
                    onClose();
                }
                _this.setOuter('');
            }
        };
        _this.renderContent = function (child, restStyle) {
            var _a;
            var _b = _this.props, needWrap = _b.needWrap, _c = _b.wrapClassName, wrapClassName = _c === void 0 ? 'dialog-wrap' : _c, _d = _b.maskClassName, maskClassName = _d === void 0 ? 'dialog-mask' : _d, maskVisible = _b.maskVisible, maskStyle = _b.maskStyle;
            return needWrap ? (react_1.default.createElement("div", { className: wrapClassName, style: restStyle, key: _this.id },
                react_1.default.createElement("div", { onClick: _this.handleMaskClick, style: __assign(__assign({}, restStyle), maskStyle), className: classnames_1.default(maskClassName, (_a = {}, _a[helper_1.getClassName('hide')] = !maskVisible, _a)) }),
                child)) : (react_1.default.createElement(react_1.default.Fragment, null, child));
        };
        _this.state = {
            visible: props.visible,
            status: motion_1.statusMap.leaveEnd,
            elementReady: false,
        };
        return _this;
    }
    Dialog.prototype.componentDidMount = function () {
        if (this.state.visible) {
            this.init();
        }
    };
    Dialog.prototype.componentDidUpdate = function (prevProps) {
        var visible = this.props.visible;
        if (prevProps.visible !== visible && this.state.visible !== visible) {
            if (visible && !this.inited) {
                this.init();
            }
            this.switchVisible(visible);
        }
    };
    Dialog.prototype.componentWillUnmount = function () {
        var _this = this;
        this.toggleBodyLock(false);
        this.clearEvent();
        var index = dialogs.findIndex(function (dialog) { return dialog.id === _this.id; });
        dialogs.splice(index, 1);
    };
    Dialog.prototype.render = function () {
        var _a = this.props, _b = _a.motionDuration, motionDuration = _b === void 0 ? 300 : _b, _c = _a.motionClassName, motionClassName = _c === void 0 ? 'dialog' : _c, children = _a.children;
        var _d = this.state, visible = _d.visible, status = _d.status, elementReady = _d.elementReady;
        var container = this.getCurrentContainer();
        var restStyle = {};
        if (container !== document.body) {
            restStyle.position = 'absolute';
        }
        return (react_1.default.createElement(portal_1.default, { visible: visible, container: container, onPortalRendered: this.handlePortalRendered },
            react_1.default.createElement(motion_1.default, { visible: visible && elementReady, onLeaveEnd: this.handleLeaveEnd, onStatusChange: this.handleStatusChange, classNames: motionClassName, duration: motionDuration }, this.renderContent(children(status), restStyle))));
    };
    Dialog.defaultProps = {
        getContainer: function () { return document.body; },
        needWrap: true,
    };
    return Dialog;
}(react_1.default.Component));
exports.default = Dialog;
//# sourceMappingURL=index.js.map