import React from 'react';
interface IProps {
    classNames: string;
    visible?: boolean;
    children: React.ReactNode;
    duration?: number;
    onEnter?: () => void;
    onEnterEnd?: () => void;
    onLeave?: () => void;
    onLeaveEnd?: () => void;
    onStatusChange?: (status: string) => void;
}
export declare const statusMap: {
    enterStart: string;
    entering: string;
    enterEnd: string;
    leaveStart: string;
    leaving: string;
    leaveEnd: string;
};
export default class Motion extends React.Component<IProps> {
    static defaultProps: {
        duration: number;
    };
    state: {
        status: string;
    };
    timer: number | null;
    constructor(props: IProps);
    componentDidMount(): void;
    statusChange: (status: string) => void;
    enterStart: () => void;
    entering: () => void;
    enterEnd: () => void;
    enterMotion: () => void;
    leaveStart: () => void;
    leaving: () => void;
    leaveEnd: () => void;
    leaveMotion: () => void;
    play: () => void;
    clearTimer: () => void;
    componentDidUpdate(prev: IProps): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)> | null;
}
export {};
