import React from 'react';
import { BaseProps } from '../interface';
declare type Position = {
    left?: number;
    top?: number;
};
export interface ContentChildProps {
    className?: string;
    dataPlacement?: string;
}
export interface IProps extends BaseProps {
    visible?: boolean;
    zIndex?: number;
    position?: Position;
    motionDuration?: number;
    motionClassName?: string;
    getWrap?: (contentWrap: React.RefObject<HTMLDivElement>) => void;
    onClickOutside?: () => void;
    onVisibleChange?: (visible: boolean) => void;
    container?: HTMLElement | false;
}
export default class Popup extends React.Component<IProps> {
    static defaultProps: {
        motionDuration: number;
        motionClassName: string;
    };
    state: {
        contentVisible: boolean;
        portalReady: boolean;
    };
    wrap: React.RefObject<HTMLDivElement>;
    initialed: boolean;
    constructor(props: IProps);
    handlePortalReady: () => void;
    getWrapEle: () => HTMLDivElement | null;
    initEvent: () => void;
    clearEvent: () => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    setContentVisible: (contentVisible: boolean) => void;
    handleContentEnter: () => void;
    handleContentLeaveEnd: () => void;
    handleDocumentClick: () => void;
    handleWrapClick: (e: React.MouseEvent<Element, MouseEvent>) => void;
    render(): JSX.Element;
}
export {};
