"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var portal_1 = __importDefault(require("../portal"));
var motion_1 = __importDefault(require("../motion"));
var Popup = /** @class */ (function (_super) {
    __extends(Popup, _super);
    function Popup(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            contentVisible: false,
            portalReady: false,
        };
        _this.wrap = react_1.default.createRef();
        _this.initialed = false;
        _this.handlePortalReady = function () {
            _this.setState({ portalReady: true });
        };
        _this.getWrapEle = function () {
            return _this.wrap && _this.wrap.current;
        };
        _this.initEvent = function () {
            document.addEventListener('click', _this.handleDocumentClick);
        };
        _this.clearEvent = function () {
            document.removeEventListener('click', _this.handleDocumentClick);
        };
        _this.setContentVisible = function (contentVisible) {
            var onVisibleChange = _this.props.onVisibleChange;
            _this.setState({
                contentVisible: contentVisible,
            }, function () {
                if (contentVisible) {
                    _this.initEvent();
                }
                else {
                    _this.clearEvent();
                }
                if (onVisibleChange)
                    onVisibleChange(contentVisible);
            });
        };
        _this.handleContentEnter = function () {
            _this.setContentVisible(true);
        };
        _this.handleContentLeaveEnd = function () {
            _this.setContentVisible(false);
        };
        _this.handleDocumentClick = function () {
            var onClickOutside = _this.props.onClickOutside;
            if (onClickOutside) {
                onClickOutside();
            }
        };
        _this.handleWrapClick = function (e) {
            e.nativeEvent.stopImmediatePropagation();
        };
        _this.state = __assign(__assign({}, _this.state), { contentVisible: props.visible || false });
        return _this;
    }
    Popup.prototype.componentDidMount = function () {
        var getWrap = this.props.getWrap;
        if (getWrap) {
            getWrap(this.wrap);
        }
    };
    Popup.prototype.componentWillUnmount = function () {
        this.clearEvent();
    };
    Popup.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, zIndex = _a.zIndex, position = _a.position, children = _a.children, visible = _a.visible, motionDuration = _a.motionDuration, motionClassName = _a.motionClassName, container = _a.container;
        var _b = this.state, contentVisible = _b.contentVisible, portalReady = _b.portalReady;
        var contentStyle = __assign(__assign({}, style), { position: 'absolute' });
        if (position && position.left != null) {
            contentStyle = __assign(__assign({}, contentStyle), position);
        }
        else {
            contentStyle.visibility = 'hidden';
        }
        if (zIndex) {
            contentStyle.zIndex = zIndex;
        }
        return (react_1.default.createElement(portal_1.default, { visible: visible, container: container, onPortalRendered: this.handlePortalReady, style: { position: 'absolute', top: 0, left: 0, width: '100%', zIndex: zIndex || 9 } },
            react_1.default.createElement("div", { className: classnames_1.default(className), onClick: this.handleWrapClick, ref: this.wrap, style: contentStyle },
                react_1.default.createElement(motion_1.default, { visible: visible && portalReady, onEnter: this.handleContentEnter, onLeaveEnd: this.handleContentLeaveEnd, duration: motionDuration, classNames: motionClassName || 'popup' }, contentVisible ? children : null))));
    };
    Popup.defaultProps = {
        motionDuration: 200,
        motionClassName: 'popup',
    };
    return Popup;
}(react_1.default.Component));
exports.default = Popup;
//# sourceMappingURL=content.js.map