"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var Close_1 = __importDefault(require("../icons/Close"));
var config_context_1 = require("../config-context");
var CheckCircle_1 = __importDefault(require("../icons/CheckCircle"));
var ExclamationCircle_1 = __importDefault(require("../icons/ExclamationCircle"));
var CloseCircle_1 = __importDefault(require("../icons/CloseCircle"));
var InfoCircle_1 = __importDefault(require("../icons/InfoCircle"));
require("./style/index.scss");
var empty = function () { };
var iconMap = {
    success: react_1.default.createElement(CheckCircle_1.default, null),
    info: react_1.default.createElement(InfoCircle_1.default, null),
    warning: react_1.default.createElement(ExclamationCircle_1.default, null),
    error: react_1.default.createElement(CloseCircle_1.default, null),
};
var Alert = function (_a) {
    var _b, _c;
    var _d = _a.afterClose, afterClose = _d === void 0 ? empty : _d, 
    // banner = false,
    className = _a.className, _e = _a.closable, closable = _e === void 0 ? false : _e, closeText = _a.closeText, desc = _a.desc, icon = _a.icon, msg = _a.msg, customPrefixCls = _a.prefixCls, _f = _a.showIcon, showIcon = _f === void 0 ? true : _f, style = _a.style, _g = _a.type, type = _g === void 0 ? 'info' : _g, _h = _a.onClose, onClose = _h === void 0 ? empty : _h;
    var prefixCls = config_context_1.getPrefixCls('alert', customPrefixCls);
    var cls = classnames_1.default(className, prefixCls, prefixCls + "-" + type, (_b = {},
        _b[prefixCls + "-without-icon"] = !showIcon,
        _b));
    var _j = react_1.useState(cls), classes = _j[0], setClasses = _j[1];
    var _k = react_1.useState(false), close = _k[0], setClose = _k[1];
    var handleClickClose = function () {
        onClose();
        setClasses(function (c) {
            return classnames_1.default(c, 'close-anim');
        });
        setTimeout(function () {
            setClose(true);
            afterClose();
        }, 250);
    };
    var typeIcon = iconMap[type] || null;
    var iconNode = (icon &&
        (react_1.default.isValidElement(icon) ? (react_1.default.cloneElement(icon, {
            className: classnames_1.default(prefixCls + "-icon", (_c = {},
                _c[icon.props.className] = icon.props.className,
                _c)),
        })) : (react_1.default.createElement("span", { className: prefixCls + "-icon" }, icon)))) ||
        react_1.default.cloneElement(typeIcon, { className: prefixCls + "-icon" });
    var closeNode = closeText ? (react_1.default.createElement("span", { className: prefixCls + "-close-text", onClick: handleClickClose }, closeText)) : (react_1.default.createElement(Close_1.default, { className: prefixCls + "-close", onClick: handleClickClose }));
    return close ? null : (react_1.default.createElement("div", { className: classes, style: style },
        react_1.default.createElement("span", { className: prefixCls + "-left-quote" }),
        showIcon ? iconNode : null,
        react_1.default.createElement("div", { className: prefixCls + "-con" },
            react_1.default.createElement("span", { className: prefixCls + "-msg" }, msg),
            react_1.default.createElement("span", { className: prefixCls + "-desc" }, desc)),
        closable && closeNode));
};
exports.default = Alert;
//# sourceMappingURL=index.js.map