"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable react/button-has-type */
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var object_omit_1 = __importDefault(require("object.omit"));
var Loading_1 = __importDefault(require("../icons/Loading"));
var Group_1 = __importDefault(require("./Group"));
require("./style/index.scss");
var defaultConfig = {
    showChildrenWhenLoading: true,
    getLoadingIcon: function () { return react_1.default.createElement(Loading_1.default, null); },
};
var defaultConfigKeys = Object.keys(defaultConfig);
var setDefaultConfig = function (config) {
    if (config === void 0) { config = {}; }
    defaultConfigKeys.forEach(function (key) {
        if (key in config) {
            defaultConfig[key] = config[key];
        }
    });
};
/**
 * @example ./doc/button.md
 */
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function () {
            var _a = _this.props, onClick = _a.onClick, loading = _a.loading, disabled = _a.disabled;
            if (!(loading || disabled) && onClick) {
                onClick();
            }
        };
        _this.shouldRenderChildren = function () {
            var _a = _this.props, showChildrenWhenLoading = _a.showChildrenWhenLoading, loading = _a.loading;
            if (!loading) {
                return true;
            }
            if ('showChildrenWhenLoading' in _this.props) {
                return showChildrenWhenLoading;
            }
            return defaultConfig.showChildrenWhenLoading;
        };
        _this.renderChildren = function () {
            var children = _this.props.children;
            return _this.shouldRenderChildren() && children;
        };
        return _this;
    }
    Button.prototype.renderLeftIcon = function (leftIcon, loading) {
        if (loading === void 0) { loading = false; }
        if (loading) {
            var getLoadingIcon = this.props.getLoadingIcon;
            return getLoadingIcon ? getLoadingIcon() : defaultConfig.getLoadingIcon();
        }
        return leftIcon;
    };
    Button.prototype.render = function () {
        var _a;
        var _b = this.props, type = _b.type, size = _b.size, htmlType = _b.htmlType, className = _b.className, empty = _b.empty, grouped = _b.grouped, disabled = _b.disabled, loading = _b.loading, leftIcon = _b.leftIcon, rightIcon = _b.rightIcon, other = __rest(_b, ["type", "size", "htmlType", "className", "empty", "grouped", "disabled", "loading", "leftIcon", "rightIcon"]);
        var classNames = classnames_1.default(className, (_a = {
                'oa-cuk-button': true,
                'oa-cuk-button-grouped': grouped,
                'oa-cuk-button-disabled': disabled,
                'oa-cuk-button-loading': loading
            },
            _a["oa-cuk-button-type-" + type] = !empty && type !== 'default',
            _a["oa-cuk-button-size-" + size] = size !== 'default',
            _a["oa-cuk-button-empty-" + type] = empty && type,
            _a));
        return (react_1.default.createElement("button", __assign({ className: classNames, type: htmlType, disabled: disabled || loading, onClick: this.handleClick }, object_omit_1.default(other, ['children', 'showChildrenWhenLoading'])),
            leftIcon || loading ? (react_1.default.createElement("span", { className: classnames_1.default({
                    'oa-cuk-button-left-icon': true,
                    'empty-children': !this.shouldRenderChildren(),
                }) }, this.renderLeftIcon(leftIcon, loading))) : null,
            this.renderChildren(),
            rightIcon ? react_1.default.createElement("span", { className: "oa-cuk-button-right-icon" }, rightIcon) : null));
    };
    Button.defaultProps = {
        htmlType: 'button',
        empty: false,
        size: 'default',
        type: 'default',
        grouped: false,
        disabled: false,
        loading: false,
        className: '',
    };
    Button.setDefaultConfig = setDefaultConfig;
    Button.Group = Group_1.default;
    return Button;
}(react_1.Component));
exports.default = Button;
//# sourceMappingURL=index.js.map