"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var classnames_1 = __importDefault(require("classnames"));
var shallowequal_1 = __importDefault(require("shallowequal"));
var object_omit_1 = __importDefault(require("object.omit"));
var Checkbox_1 = __importDefault(require("./Checkbox"));
var config_context_1 = require("../config-context");
var CheckboxGroup = /** @class */ (function (_super) {
    __extends(CheckboxGroup, _super);
    function CheckboxGroup(props) {
        var _this = _super.call(this, props) || this;
        _this.cancelValue = function (value) {
            _this.setState(function (_a) {
                var registeredValues = _a.registeredValues;
                return ({
                    registeredValues: registeredValues.filter(function (val) { return val !== value; }),
                });
            });
        };
        _this.registerValue = function (value) {
            _this.setState(function (_a) {
                var registeredValues = _a.registeredValues;
                return ({
                    registeredValues: __spreadArrays(registeredValues, [value]),
                });
            });
        };
        _this.toggleOption = function (option) {
            var registeredValues = _this.state.registeredValues;
            var optionIndex = _this.state.value.indexOf(option.value);
            var value = __spreadArrays(_this.state.value);
            if (optionIndex === -1) {
                value.push(option.value);
            }
            else {
                value.splice(optionIndex, 1);
            }
            if (!('value' in _this.props)) {
                _this.setState({ value: value });
            }
            var onChange = _this.props.onChange;
            if (onChange) {
                var options_1 = _this.getOptions();
                onChange(value
                    .filter(function (val) { return registeredValues.indexOf(val) !== -1; })
                    .sort(function (a, b) {
                    var indexA = options_1.findIndex(function (opt) { return opt.value === a; });
                    var indexB = options_1.findIndex(function (opt) { return opt.value === b; });
                    return indexA - indexB;
                }));
            }
        };
        _this.renderGroup = function (_a) {
            var getPrefixCls = _a.getPrefixCls;
            var _b = _this, props = _b.props, state = _b.state;
            var customizePrefixCls = props.prefixCls, className = props.className, style = props.style, options = props.options, restProps = __rest(props, ["prefixCls", "className", "style", "options"]);
            var prefixCls = getPrefixCls('checkbox', customizePrefixCls);
            var groupPrefixCls = prefixCls + "-group";
            var domProps = object_omit_1.default(restProps, ['children', 'defaultValue', 'value', 'onChange', 'disabled']);
            var children = props.children;
            if (options && options.length > 0) {
                children = _this.getOptions().map(function (option) { return (react_1.default.createElement(Checkbox_1.default, { prefixCls: prefixCls, key: option.value.toString(), disabled: 'disabled' in option ? option.disabled : props.disabled, value: option.value, checked: state.value.indexOf(option.value) !== -1, onChange: option.onChange, className: groupPrefixCls + "-item" }, option.label)); });
            }
            var classString = classnames_1.default(groupPrefixCls, className);
            return (react_1.default.createElement("div", __assign({ className: classString, style: style }, domProps), children));
        };
        _this.state = {
            value: props.value || props.defaultValue || [],
            registeredValues: [],
        };
        return _this;
    }
    CheckboxGroup.getDerivedStateFromProps = function (nextProps) {
        if ('value' in nextProps) {
            return {
                value: nextProps.value || [],
            };
        }
        return null;
    };
    CheckboxGroup.prototype.getChildContext = function () {
        return {
            checkboxGroup: {
                toggleOption: this.toggleOption,
                value: this.state.value,
                disabled: this.props.disabled,
                name: this.props.name,
                registerValue: this.registerValue,
                cancelValue: this.cancelValue,
            },
        };
    };
    CheckboxGroup.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowequal_1.default(this.props, nextProps) || !shallowequal_1.default(this.state, nextState);
    };
    CheckboxGroup.prototype.getOptions = function () {
        var options = this.props.options;
        // https://github.com/Microsoft/TypeScript/issues/7960
        return options.map(function (option) {
            if (typeof option === 'string') {
                return {
                    label: option,
                    value: option,
                };
            }
            return option;
        });
    };
    CheckboxGroup.prototype.render = function () {
        return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderGroup);
    };
    CheckboxGroup.defaultProps = {
        options: [],
    };
    CheckboxGroup.propTypes = {
        defaultValue: prop_types_1.default.array,
        value: prop_types_1.default.array,
        options: prop_types_1.default.array.isRequired,
        onChange: prop_types_1.default.func,
    };
    CheckboxGroup.childContextTypes = {
        checkboxGroup: prop_types_1.default.any,
    };
    return CheckboxGroup;
}(react_1.default.Component));
exports.default = CheckboxGroup;
//# sourceMappingURL=Group.js.map