"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var dayjs_1 = __importDefault(require("dayjs"));
var AngleDoubleRight_1 = __importDefault(require("../../icons/AngleDoubleRight"));
var AngleDoubleLeft_1 = __importDefault(require("../../icons/AngleDoubleLeft"));
var AngleLeft_1 = __importDefault(require("../../icons/AngleLeft"));
var AngleRight_1 = __importDefault(require("../../icons/AngleRight"));
var helper_1 = require("../../_base/helper");
var panelType_1 = __importDefault(require("./panelType"));
var calculate_1 = require("../utils/calculate");
function PanelHeader(props) {
    var type = props.type, current = props.current, langData = props.langData, onYearChange = props.onYearChange, onMonthChange = props.onMonthChange, onSelectMonth = props.onSelectMonth, onSelectYear = props.onSelectYear;
    var renderYearArrow = function () {
        if (!type) {
            return null;
        }
        return (react_1.default.createElement("dd", { className: helper_1.getClassName('year-action-arrow-wrap') },
            react_1.default.createElement("a", { onClick: onYearChange.bind(null, false) },
                react_1.default.createElement(AngleDoubleLeft_1.default, null)),
            react_1.default.createElement("a", { onClick: onYearChange.bind(null, true) },
                react_1.default.createElement(AngleDoubleRight_1.default, null))));
    };
    var renderMonthArrow = function () {
        if (type > panelType_1.default.dateTime || !type) {
            return null;
        }
        return (react_1.default.createElement("dd", { className: helper_1.getClassName('month-action-arrow-wrap') },
            react_1.default.createElement("a", { onClick: onMonthChange.bind(null, false) },
                react_1.default.createElement(AngleLeft_1.default, null)),
            react_1.default.createElement("a", { onClick: onMonthChange.bind(null, true) },
                react_1.default.createElement(AngleRight_1.default, null))));
    };
    var renderContent = function () {
        var year = react_1.default.createElement("a", { onClick: onSelectYear }, dayjs_1.default(current).format(langData.dateFormat.year));
        var month = react_1.default.createElement("a", { onClick: onSelectMonth }, dayjs_1.default(current).format(langData.dateFormat.month));
        var content = null;
        switch (type) {
            case panelType_1.default.date:
            case panelType_1.default.dateTime:
                content = (react_1.default.createElement("span", null,
                    year,
                    " ",
                    month));
                break;
            case panelType_1.default.month:
                content = react_1.default.createElement("span", null, year);
                break;
            case panelType_1.default.year:
                content = react_1.default.createElement("span", null, calculate_1.getYearRange(current).join('-'));
                break;
            case panelType_1.default.time:
                content = react_1.default.createElement("span", null, current.format('YYYY-MM-DD'));
                break;
            default:
                content = null;
                break;
        }
        return react_1.default.createElement("dd", { className: helper_1.getClassName('header-content') }, content);
    };
    return (react_1.default.createElement("dl", { className: helper_1.getClassName('date-picker-header') },
        renderYearArrow(),
        renderMonthArrow(),
        renderContent()));
}
exports.default = PanelHeader;
//# sourceMappingURL=header.js.map