"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var calculate_1 = require("../utils/calculate");
var helper_1 = require("../../_base/helper");
function scrollToTop(target, top, ease, doneFunc) {
    if (top === void 0) { top = 0; }
    if (ease === void 0) { ease = false; }
    if (!target) {
        return;
    }
    var start = target.scrollTop;
    var times = 15;
    var step = (top - start) / times;
    var current = 1;
    var scroll = function () {
        if (current < times && step && ease) {
            target.scrollTo(0, start + current * step);
            current++;
            requestAnimationFrame(scroll);
        }
        else {
            target.scrollTo(0, top);
            if (doneFunc) {
                doneFunc();
            }
        }
    };
    scroll();
}
function TimeBody(props) {
    var current = props.current, onChange = props.onChange, timeStep = props.timeStep, disableTime = props.disableTime, largePanel = props.largePanel, showHours = props.showHours, showMinutes = props.showMinutes, showSeconds = props.showSeconds, langData = props.langData;
    var hourColumn = react_1.useRef();
    var minuteColumn = react_1.useRef();
    var secondColumn = react_1.useRef();
    var _a = react_1.useState({ hour: false, minute: false, second: false }), easeScroll = _a[0], setEaseScroll = _a[1];
    var timeListMap = calculate_1.getTimeList(current, timeStep, disableTime);
    var hourList = timeListMap.h;
    var minuteList = timeListMap.m;
    var secondList = timeListMap.s;
    react_1.useEffect(function () {
        var hourCheckedIndex = hourList.findIndex(function (item) { return item.checked; });
        var minuteCheckedIndex = minuteList.findIndex(function (item) { return item.checked; });
        var secondCheckedIndex = secondList.findIndex(function (item) { return item.checked; });
        scrollToTop(hourColumn === null || hourColumn === void 0 ? void 0 : hourColumn.current, calculate_1.getTimeColumnScrollTop(hourCheckedIndex), easeScroll.hour, function () { return setEaseScroll(__assign(__assign({}, easeScroll), { hour: false })); });
        scrollToTop(minuteColumn === null || minuteColumn === void 0 ? void 0 : minuteColumn.current, calculate_1.getTimeColumnScrollTop(minuteCheckedIndex), easeScroll.minute, function () { return setEaseScroll(__assign(__assign({}, easeScroll), { minute: false })); });
        scrollToTop(secondColumn === null || secondColumn === void 0 ? void 0 : secondColumn.current, calculate_1.getTimeColumnScrollTop(secondCheckedIndex), easeScroll.second, function () { return setEaseScroll(__assign(__assign({}, easeScroll), { second: false })); });
    }, [current.hour(), current.minute(), current.second()]);
    var handleClick = function (type, dateNode) {
        var _a;
        if (!dateNode.disabled) {
            setEaseScroll(__assign(__assign({}, easeScroll), (_a = {}, _a[type] = true, _a)));
            onChange(current[type](dateNode.value));
        }
    };
    return (react_1.default.createElement("div", { className: helper_1.getClassName([
            'date-picker-body-wrap',
            'date-picker-time-body-wrap',
            { 'date-picker-time-body-large': largePanel },
        ]) },
        react_1.default.createElement("div", { className: helper_1.getClassName('date-picker-time-select-column', { visible: showHours }) },
            react_1.default.createElement("h4", { className: helper_1.getClassName('date-picker-time-select-title') }, langData.text.hour),
            react_1.default.createElement("ul", { ref: hourColumn }, hourList.map(function (item) { return (react_1.default.createElement("li", { className: helper_1.getClassName([
                    'date-picker-time-item',
                    {
                        'date-picker-time-item-disabled': item.disabled,
                        'date-picker-time-item-checked': item.checked,
                    },
                ]), key: "hour-" + item.text, onClick: handleClick.bind(null, 'hour', item) }, item.text)); }))),
        react_1.default.createElement("div", { className: helper_1.getClassName('date-picker-time-select-column', { visible: showMinutes }) },
            react_1.default.createElement("h4", { className: helper_1.getClassName('date-picker-time-select-title') }, langData.text.minute),
            react_1.default.createElement("ul", { ref: minuteColumn }, minuteList.map(function (item) { return (react_1.default.createElement("li", { className: helper_1.getClassName([
                    'date-picker-time-item',
                    {
                        'date-picker-time-item-disabled': item.disabled,
                        'date-picker-time-item-checked': item.checked,
                    },
                ]), key: "minute-" + item.text, onClick: handleClick.bind(null, 'minute', item) }, item.text)); }))),
        react_1.default.createElement("div", { className: helper_1.getClassName('date-picker-time-select-column', { visible: showSeconds }) },
            react_1.default.createElement("h4", { className: helper_1.getClassName('date-picker-time-select-title') }, langData.text.second),
            react_1.default.createElement("ul", { ref: secondColumn }, secondList.map(function (item) { return (react_1.default.createElement("li", { className: helper_1.getClassName([
                    'date-picker-time-item',
                    {
                        'date-picker-time-item-disabled': item.disabled,
                        'date-picker-time-item-checked': item.checked,
                    },
                ]), key: "second-" + item.text, onClick: handleClick.bind(null, 'second', item) }, item.text)); })))));
}
exports.default = TimeBody;
//# sourceMappingURL=timeBody.js.map