import { Dayjs } from 'dayjs';
import { TLang } from './I18n';
export interface IDateNode {
    value: number;
    text: string;
    disabled?: boolean;
    checked?: boolean;
    isCurrent?: boolean;
    out?: boolean;
}
export interface IDisableTime {
    h: Array<number>;
    m: Array<number>;
    s: Array<number>;
}
export interface ITimeStep {
    h: number;
    m: number;
    s: number;
}
export declare function getDateList(current: Dayjs, disableDate?: (date: Dayjs) => boolean): IDateNode[];
export declare function getMonthList(current: Dayjs, langData: TLang): IDateNode[];
export declare function getYearList(current: Dayjs): IDateNode[];
export declare function getYearRange(current: Dayjs): number[];
export declare function getTimeList(current: Dayjs, step?: ITimeStep, disableTime?: IDisableTime): {
    h: IDateNode[];
    m: IDateNode[];
    s: IDateNode[];
};
export declare function getTimeColumnScrollTop(index: number): number;
