import React from 'react';
import { BaseProps } from '../_base/interface';
import Dialog from '../_base/dialog';
import './style/index.scss';
export interface IProps extends BaseProps {
    visible: boolean;
    maskVisible?: boolean;
    maskCloseable?: boolean;
    escCloseable?: boolean;
    closeable?: boolean;
    placement?: 'left' | 'top' | 'right' | 'bottom';
    title?: React.ReactNode;
    maskStyle?: React.CSSProperties;
    maskClassName?: string;
    needWrap?: boolean;
    getContainer?: () => HTMLElement | false;
}
export default class Drawer extends React.Component<IProps> {
    static defaultProps: {
        visible: boolean;
        maskVisible: boolean;
        closeable: boolean;
        escCloseable: boolean;
        maskCloseable: boolean;
        needWrap: boolean;
        placement: string;
        onClose: () => void;
        getContainer: () => HTMLElement;
    };
    dialog: React.RefObject<Dialog>;
    handleClose: () => void;
    renderCloseBtn: () => JSX.Element | null;
    renderTitle: () => JSX.Element | null;
    render(): JSX.Element;
}
