"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-a11y/click-events-have-key-events */
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var motion_1 = require("../_base/motion");
var Close_1 = __importDefault(require("../icons/Close"));
var helper_1 = require("../_base/helper");
var dialog_1 = __importDefault(require("../_base/dialog"));
require("./style/index.scss");
var getTranslate = function (placement, status) {
    if (placement === void 0) { placement = 'right'; }
    if (status === void 0) { status = 'leaveEnd'; }
    var map = {
        left: {
            enterStart: 'translateX(-100%)',
            entering: 'translateX(0)',
            leaveStart: 'translateX(0)',
            leaving: 'translateX(-100%)',
        },
        top: {
            enterStart: 'translateY(-100%)',
            entering: 'translateY(0)',
            leaveStart: 'translateY(0)',
            leaving: 'translateY(-100%)',
        },
        right: {
            enterStart: 'translateX(100%)',
            entering: 'translateX(0)',
            leaveStart: 'translateX(0)',
            leaving: 'translateX(100%)',
        },
        bottom: {
            enterStart: 'translateY(100%)',
            entering: 'translateY(0)',
            leaveStart: 'translateY(0)',
            leaving: 'translateY(100%)',
        },
    };
    return map[placement][status];
};
var Drawer = /** @class */ (function (_super) {
    __extends(Drawer, _super);
    function Drawer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dialog = react_1.default.createRef();
        _this.handleClose = function () {
            if (_this.dialog && _this.dialog.current) {
                _this.dialog.current.close();
            }
        };
        _this.renderCloseBtn = function () {
            if (!_this.props.closeable) {
                return null;
            }
            return (react_1.default.createElement("div", { onClick: _this.handleClose, className: helper_1.getClassName('drawer-close') },
                react_1.default.createElement(Close_1.default, null)));
        };
        _this.renderTitle = function () {
            var title = _this.props.title;
            var titleClassName = helper_1.getClassName('drawer-title');
            if (!title) {
                return null;
            }
            if (['number', 'string'].includes(typeof title)) {
                return react_1.default.createElement("h4", { className: titleClassName }, title);
            }
            title = react_1.default.cloneElement(react_1.default.Children.only(title), {
                className: classnames_1.default(titleClassName, title.props.className),
            });
            return react_1.default.createElement(react_1.default.Fragment, null, title);
        };
        return _this;
    }
    Drawer.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, placement = _a.placement, style = _a.style, maskClassName = _a.maskClassName, children = _a.children, needWrap = _a.needWrap, getContainer = _a.getContainer, others = __rest(_a, ["className", "placement", "style", "maskClassName", "children", "needWrap", "getContainer"]);
        var container = getContainer ? getContainer() : null;
        return (react_1.default.createElement(dialog_1.default, __assign({}, others, { getContainer: getContainer, needWrap: needWrap, motionClassName: helper_1.getClassName('drawer'), maskClassName: classnames_1.default(helper_1.getClassName('drawer-mask'), maskClassName), wrapClassName: helper_1.getClassName('drawer-wrap'), ref: this.dialog }), function (status) {
            var _a;
            if (status === void 0) { status = ''; }
            var contentStyle = __assign(__assign({}, style), { transform: getTranslate(placement, status) });
            if (!needWrap && container === document.body) {
                contentStyle.position = 'fixed';
            }
            var contentClassName = classnames_1.default(helper_1.getClassName('drawer-content'), helper_1.getClassName("drawer-content-" + placement), className, (_a = {}, _a[helper_1.getClassName("drawer-content-" + motion_1.statusMap[status])] = !needWrap, _a));
            return (react_1.default.createElement("div", { style: contentStyle, className: contentClassName },
                _this.renderCloseBtn(),
                _this.renderTitle(),
                children));
        }));
    };
    Drawer.defaultProps = {
        visible: false,
        maskVisible: true,
        closeable: true,
        escCloseable: true,
        maskCloseable: true,
        needWrap: true,
        placement: 'right',
        onClose: function () { },
        getContainer: function () { return document.body; },
    };
    return Drawer;
}(react_1.default.Component));
exports.default = Drawer;
//# sourceMappingURL=index.js.map