"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var throttle_1 = __importDefault(require("lodash/throttle"));
var Loading_1 = __importDefault(require("../icons/Loading"));
var LazyLoadContainer = /** @class */ (function (_super) {
    __extends(LazyLoadContainer, _super);
    function LazyLoadContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.container = react_1.default.createRef();
        _this.scrollEventRegisterHandler = function (isAdd) {
            var container = _this.container.current;
            var eventName = 'scroll';
            var cb = _this.onScroll;
            if (isAdd) {
                container.addEventListener(eventName, cb);
            }
            else {
                container.removeEventListener(eventName, cb);
            }
        };
        _this.onScroll = function () {
            var _a = _this.props, offset = _a.offset, onScrollBottom = _a.onScrollBottom;
            var container = _this.container.current;
            var offsetBottom = container.scrollHeight - container.scrollTop - container.clientHeight;
            // 假如距离底部 <= offset
            if (offsetBottom <= offset) {
                onScrollBottom();
            }
        };
        _this.renderLoading = function () {
            var loadingComponent = _this.props.loadingComponent;
            if (loadingComponent) {
                return loadingComponent;
            }
            return (react_1.default.createElement("div", { className: "oa-cuk-dropdown-menu-lazy-load-icon-container" },
                react_1.default.createElement(Loading_1.default, null),
                react_1.default.createElement("span", { className: "oa-cuk-dropdown-menu-lazy-load-icon-text" }, "\u52A0\u8F7D\u4E2D...")));
        };
        _this.onScroll = throttle_1.default(_this.onScroll, 100);
        return _this;
    }
    LazyLoadContainer.prototype.componentDidMount = function () {
        this.scrollEventRegisterHandler(true);
    };
    LazyLoadContainer.prototype.componentWillUnmount = function () {
        this.scrollEventRegisterHandler(false);
    };
    LazyLoadContainer.prototype.render = function () {
        var _a = this.props, className = _a.className, children = _a.children, isLoading = _a.isLoading;
        return (react_1.default.createElement("div", { className: className, ref: this.container },
            children,
            isLoading && this.renderLoading()));
    };
    LazyLoadContainer.defaultProps = {
        offset: 0,
        onScrollBottom: function () { },
    };
    return LazyLoadContainer;
}(react_1.default.Component));
exports.default = LazyLoadContainer;
//# sourceMappingURL=LazyLoadContainer.js.map