"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var AngleDown_1 = __importDefault(require("../icons/AngleDown"));
var Trigger = function (props) {
    var triggerRef = react_1.default.useRef(null);
    var selected = props.selected, labelKey = props.labelKey, className = props.className, _a = props.prefixCls, prefixCls = _a === void 0 ? 'oa-cuk-dropdown' : _a, triggerPrefix = props.triggerPrefix, triggerSuffix = props.triggerSuffix, triggerText = props.triggerText, disabled = props.disabled, triggerBorderless = props.triggerBorderless, isTriggerTextAppendable = props.isTriggerTextAppendable, onClick = props.onClick, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave;
    var classes = classnames_1.default(className, prefixCls + "-trigger", disabled, {
        borderless: triggerBorderless,
    });
    var seletedText = '';
    if (selected && selected.length) {
        seletedText = selected.map(function (item) { return item[labelKey]; }).join(',');
    }
    var text = isTriggerTextAppendable ? triggerText + seletedText : seletedText || triggerText;
    return (react_1.default.createElement("div", { onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave, onClick: onClick, ref: triggerRef, className: classes },
        triggerPrefix && react_1.default.createElement("span", { className: prefixCls + "-trigger-prefix-icon" }, triggerPrefix),
        react_1.default.createElement("div", { className: prefixCls + "-trigger-text" }, text),
        react_1.default.createElement("span", { className: prefixCls + "-trigger-suffix-icon" }, triggerSuffix || react_1.default.createElement(AngleDown_1.default, null))));
};
Trigger.defaultProps = {
    triggerText: '',
};
exports.default = Trigger;
//# sourceMappingURL=Trigger.js.map