"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var config_context_1 = require("../config-context");
var empty_1 = __importDefault(require("./empty"));
var simple_1 = __importDefault(require("./simple"));
var inbox_1 = __importDefault(require("./inbox"));
require("./style/index.scss");
var defaultEmptyImg = react_1.default.createElement(empty_1.default, null);
var simpleEmptyImg = react_1.default.createElement(simple_1.default, null);
var emptyInboxImg = react_1.default.createElement(inbox_1.default, null);
var Empty = function (props) { return (react_1.default.createElement(config_context_1.ConfigConsumer, null, function (_a) {
    var _b;
    var getPrefixCls = _a.getPrefixCls;
    var className = props.className, customizePrefixCls = props.prefixCls, _c = props.image, image = _c === void 0 ? defaultEmptyImg : _c, description = props.description, children = props.children, imageStyle = props.imageStyle, restProps = __rest(props, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
    var prefixCls = getPrefixCls('empty', customizePrefixCls);
    var des = typeof description !== 'undefined' ? description : undefined;
    var alt = typeof des === 'string' ? des : 'empty';
    var imageNode = null;
    if (typeof image === 'string') {
        imageNode = react_1.default.createElement("img", { alt: alt, src: image });
    }
    else {
        imageNode = image;
    }
    return (react_1.default.createElement("div", __assign({ className: classnames_1.default(prefixCls, (_b = {},
            _b[prefixCls + "-normal"] = image === simpleEmptyImg,
            _b), className) }, restProps),
        react_1.default.createElement("div", { className: prefixCls + "-image", style: imageStyle }, imageNode),
        des && react_1.default.createElement("p", { className: prefixCls + "-description" }, des),
        children && react_1.default.createElement("div", { className: prefixCls + "-footer" }, children)));
})); };
Empty.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
Empty.EMPTY_INBOX = emptyInboxImg;
exports.default = Empty;
//# sourceMappingURL=index.js.map