"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var object_omit_1 = __importDefault(require("object.omit"));
var Loading_1 = __importDefault(require("../icons/Loading"));
var Search_1 = __importDefault(require("../icons/Search"));
var Input_1 = __importDefault(require("./Input"));
var Search = /** @class */ (function (_super) {
    __extends(Search, _super);
    function Search() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.input = react_1.default.createRef();
        _this.handleSearchClick = function () {
            var value = '';
            if (_this.input && _this.input.current) {
                var inputValue = _this.input.current.state.value;
                value = isEmpty_1.default(inputValue) ? '' : "" + inputValue;
            }
            _this.search(value);
        };
        _this.handlePressEnter = function (value) {
            var onPressEnter = _this.props.onPressEnter;
            _this.search(value);
            if (onPressEnter)
                onPressEnter(value);
        };
        _this.search = function (value) {
            var onSearch = _this.props.onSearch;
            if (onSearch) {
                onSearch(value);
            }
        };
        return _this;
    }
    Search.prototype.render = function () {
        var _a = this.props, loading = _a.loading, others = __rest(_a, ["loading"]);
        var resetProps = object_omit_1.default(others, ['onSearch']);
        return (react_1.default.createElement(Input_1.default, __assign({}, resetProps, { suffix: loading ? (react_1.default.createElement(Loading_1.default, null)) : (react_1.default.createElement(Search_1.default, { style: { cursor: 'pointer' }, onClick: this.handleSearchClick })), onPressEnter: this.handlePressEnter, ref: this.input, clearable: false })));
    };
    return Search;
}(react_1.default.Component));
exports.default = Search;
//# sourceMappingURL=Search.js.map