import React from 'react';
import { BaseProps } from '../_base/interface';
import './style/index.scss';
export interface IProps extends BaseProps {
    rows?: number;
    cols?: number;
    value?: string;
    defaultValue?: string;
    id?: string;
    name?: string;
    placeholder?: string;
    disabled?: boolean;
    maxLength?: number;
    onChange?: (value?: string) => void;
    onFocus?: (e?: React.FocusEvent) => void;
    onBlur?: (e?: React.FocusEvent) => void;
}
interface IState {
    value: string | undefined;
}
export default class Textarea extends React.Component<IProps> {
    state: IState;
    textarea: React.RefObject<HTMLTextAreaElement>;
    static getDerivedStateFromProps(props: IProps, state: IState): {
        value: string | undefined;
    };
    static defaultProps: {
        rows: number;
        placeholder: string;
    };
    constructor(props: IProps);
    handleChange: (e: React.ChangeEvent<HTMLTextAreaElement>) => void;
    render(): JSX.Element;
}
export {};
