"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var object_omit_1 = __importDefault(require("object.omit"));
var classnames_1 = __importDefault(require("classnames"));
var helper_1 = require("../_base/helper");
require("./style/index.scss");
var Textarea = /** @class */ (function (_super) {
    __extends(Textarea, _super);
    function Textarea(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            value: '',
        };
        _this.textarea = react_1.default.createRef();
        _this.handleChange = function (e) {
            var onChange = _this.props.onChange;
            var value = e.target.value;
            _this.setState({ value: value });
            if (onChange) {
                onChange(value);
            }
        };
        var defaultValue = props.defaultValue, value = props.value;
        _this.state = { value: value || defaultValue || '' };
        return _this;
    }
    Textarea.getDerivedStateFromProps = function (props, state) {
        if (props.value !== undefined && state.value !== props.value) {
            return { value: props.value };
        }
        return { value: state.value };
    };
    Textarea.prototype.render = function () {
        var _a = this.props, className = _a.className, disabled = _a.disabled, others = __rest(_a, ["className", "disabled"]);
        var resetProps = object_omit_1.default(others, ['onChange', 'value', 'defaultValue']);
        return (react_1.default.createElement("textarea", __assign({}, resetProps, { disabled: disabled, className: classnames_1.default(helper_1.getClassName(['textarea', { 'textarea-disabled': disabled }]), className), onChange: this.handleChange, value: this.state.value })));
    };
    Textarea.defaultProps = {
        rows: 2,
        placeholder: '请输入',
    };
    return Textarea;
}(react_1.default.Component));
exports.default = Textarea;
//# sourceMappingURL=Textarea.js.map