"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
exports.VERTICAL_MODE = 'vertical';
exports.INLINE_MODE = 'inline';
exports.INLINE_COLLAPSED_MODE = 'inline-collapsed';
exports.DARK_THEME = 'dark';
exports.LIGHT_THEME = 'light';
/**
 * @example ./doc/menu.md
 */
var Menu = /** @class */ (function (_super) {
    __extends(Menu, _super);
    function Menu(props) {
        var _this = _super.call(this, props) || this;
        _this.isRootMenu = true;
        _this.renderItem = function (child, index, subIndex, outer) {
            if (outer === void 0) { outer = false; }
            var key = child.key;
            // @ts-ignore
            var isSubMenu = child.type.isSubMenu;
            var _a = _this.props, onSelect = _a.onSelect, activeKey = _a.activeKey, mode = _a.mode, theme = _a.theme, open = _a.open;
            var newChildProps = {
                index: index,
                key: key,
                subIndex: subIndex,
                active: key === activeKey,
                activeKey: activeKey,
                renderItem: _this.renderItem,
                theme: theme,
                mode: mode,
                outer: outer,
                parentMenu: _this,
                open: open,
                onSelect: onSelect,
            };
            if (isSubMenu) {
                newChildProps.onSelect = function () {
                    _this.onSubMenuSelect(key);
                };
                newChildProps.open = _this.state.openKeys.includes(key);
                newChildProps.active = child.props.children.some(function (c) { return c.key === _this.state.activeKey; });
            }
            else {
                newChildProps.onSelect = function () {
                    onSelect(key);
                };
            }
            return react_1.default.cloneElement(child, newChildProps);
        };
        _this.onSubMenuSelect = function (key) {
            var currentOpenKeys = _this.state.openKeys;
            var nextOpenKeys = currentOpenKeys.includes(key)
                ? currentOpenKeys.filter(function (k) { return k !== key; })
                : __spreadArrays(currentOpenKeys, [key]);
            if ('onOpenChange' in _this.props) {
                _this.props.onOpenChange(nextOpenKeys, key);
            }
            if (!('openKeys' in _this.props)) {
                _this.setState({
                    openKeys: nextOpenKeys,
                });
            }
        };
        _this.state = {
            openKeys: 'openKeys' in props ? props.openKeys : props.defaultOpenKeys,
            activeKey: 'activeKey' in props ? props.activeKey : props.defaultActiveKey,
        };
        return _this;
    }
    Menu.getDerivedStateFromProps = function (nextProps, prevState) {
        var openKeys = prevState.openKeys;
        var activeKey = prevState.activeKey;
        if ('openKeys' in nextProps) {
            openKeys = nextProps.openKeys;
        }
        if ('activeKey' in nextProps) {
            activeKey = nextProps.activeKey;
        }
        return { openKeys: openKeys, activeKey: activeKey };
    };
    Menu.prototype.render = function () {
        var _a;
        var _this = this;
        var _b = this.props, children = _b.children, className = _b.className, theme = _b.theme, style = _b.style, mode = _b.mode;
        var classNames = classnames_1.default((_a = {
                className: className,
                'oa-cuk-menu clearfix': true
            },
            _a["oa-cuk-menu-theme-" + theme] = theme,
            _a['oa-cuk-menu-inline-collapsed'] = mode === exports.INLINE_COLLAPSED_MODE,
            _a));
        return (react_1.default.createElement("ul", { className: classNames, style: style }, react_1.default.Children.map(children, function (child, index) { return _this.renderItem(child, index, -1, true); })));
    };
    Menu.defaultProps = {
        // eslint-disable-next-line no-unused-vars
        onSelect: function (key) { return null; },
        defaultOpenKeys: [],
        theme: exports.LIGHT_THEME,
        mode: exports.VERTICAL_MODE,
        className: '',
        style: {},
    };
    return Menu;
}(react_1.default.Component));
exports.default = Menu;
//# sourceMappingURL=Menu.js.map