"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-a11y/click-events-have-key-events */
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var Close_1 = __importDefault(require("../icons/Close"));
var button_1 = __importDefault(require("../button"));
var dialog_1 = __importDefault(require("../_base/dialog"));
var motion_1 = require("../_base/motion");
var helper_1 = require("../_base/helper");
require("./style/index.scss");
var getFooterAlign = function (align) {
    return ({
        left: 'flex-start',
        center: 'center',
        right: 'flex-end',
    }[align] || 'flex-start');
};
var Modal = /** @class */ (function (_super) {
    __extends(Modal, _super);
    function Modal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dialog = react_1.default.createRef();
        _this.handleOk = function () {
            if (_this.props.onOk) {
                _this.props.onOk();
            }
        };
        _this.handleClose = function () {
            if (_this.dialog && _this.dialog.current) {
                _this.dialog.current.close();
            }
        };
        _this.handleCancel = function () {
            _this.handleClose();
            if (_this.props.onCancel) {
                _this.props.onCancel();
            }
        };
        _this.renderTitle = function () {
            var title = _this.props.title;
            if (!title) {
                return null;
            }
            if (['number', 'string'].includes(typeof title)) {
                return react_1.default.createElement("h4", { className: helper_1.getClassName('modal-title') }, title);
            }
            title = react_1.default.cloneElement(react_1.default.Children.only(title), {
                className: classnames_1.default(helper_1.getClassName('modal-title'), title.props.className),
            });
            return react_1.default.createElement(react_1.default.Fragment, null, title);
        };
        _this.renderFooter = function () {
            var _a = _this.props, footer = _a.footer, _b = _a.okText, okText = _b === void 0 ? '确定' : _b, _c = _a.cancelText, cancelText = _c === void 0 ? '取消' : _c, loading = _a.loading, okBtnVisible = _a.okBtnVisible, cancelBtnVisible = _a.cancelBtnVisible, footerAlign = _a.footerAlign;
            if (footer == null || (!okBtnVisible && !cancelBtnVisible)) {
                return null;
            }
            var footerContent = (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(button_1.default, { loading: loading, onClick: _this.handleOk, className: helper_1.getClassName('modal-btn-ok', { visible: okBtnVisible }) }, okText),
                react_1.default.createElement(button_1.default, { empty: true, onClick: _this.handleCancel, className: helper_1.getClassName('modal-btn-cancel', { visible: cancelBtnVisible }) }, cancelText)));
            if (typeof footer !== 'boolean') {
                footerContent = footer;
            }
            var footerStyle = {};
            if (footerAlign) {
                footerStyle.justifyContent = getFooterAlign(footerAlign);
            }
            return (react_1.default.createElement("div", { className: helper_1.getClassName('modal-footer'), style: footerStyle }, footerContent));
        };
        return _this;
    }
    Modal.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, closeable = _a.closeable, className = _a.className, style = _a.style, width = _a.width, top = _a.top, centered = _a.centered, icon = _a.icon, iconColor = _a.iconColor, maskClassName = _a.maskClassName, others = __rest(_a, ["children", "closeable", "className", "style", "width", "top", "centered", "icon", "iconColor", "maskClassName"]);
        var contentStyle = __assign({}, style);
        var iconStyle = {};
        var hasIcon = icon != null;
        if (iconColor) {
            iconStyle.color = iconColor;
        }
        if (width) {
            contentStyle.width = width;
        }
        if (!centered) {
            contentStyle.top = top;
        }
        return (react_1.default.createElement(dialog_1.default, __assign({}, others, { motionClassName: helper_1.getClassName('modal'), maskClassName: classnames_1.default(helper_1.getClassName('modal-mask'), maskClassName), wrapClassName: helper_1.getClassName('modal-wrap'), ref: this.dialog }), function (status) {
            var _a;
            return (react_1.default.createElement("div", { className: classnames_1.default(helper_1.getClassName('modal-content'), helper_1.getClassName("modal-content-" + motion_1.statusMap[status]), className, (_a = {},
                    _a[helper_1.getClassName('modal-center')] = centered,
                    _a[helper_1.getClassName('modal-with-icon')] = hasIcon,
                    _a)), style: contentStyle },
                react_1.default.createElement("div", { className: helper_1.getClassName('modal-close-btn', { visible: closeable }), onClick: _this.handleClose },
                    react_1.default.createElement(Close_1.default, null)),
                hasIcon && (react_1.default.createElement("div", { className: helper_1.getClassName('modal-icon'), style: iconStyle }, icon)),
                react_1.default.createElement("div", { className: helper_1.getClassName('modal-content-main') },
                    _this.renderTitle(),
                    react_1.default.createElement("div", { className: helper_1.getClassName('modal-body') }, children),
                    _this.renderFooter())));
        }));
    };
    Modal.defaultProps = {
        visible: false,
        maskVisible: true,
        closeable: true,
        escCloseable: true,
        maskCloseable: true,
        footer: true,
        footerAlign: 'left',
        cancelBtnVisible: true,
        okBtnVisible: true,
        centered: false,
        width: 520,
        top: '10%',
        onClose: function () { },
        getContainer: function () { return document.body; },
    };
    return Modal;
}(react_1.default.Component));
exports.default = Modal;
//# sourceMappingURL=modal.js.map