"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var rc_pagination_1 = __importDefault(require("rc-pagination"));
var classnames_1 = __importDefault(require("classnames"));
// import Select from 'rc-select'
var config_context_1 = require("../config-context");
var responsiveObserve_1 = __importDefault(require("../_util/responsiveObserve"));
var miniSelect_1 = __importDefault(require("./miniSelect"));
var AngleLeft_1 = __importDefault(require("../icons/AngleLeft"));
var AngleRight_1 = __importDefault(require("../icons/AngleRight"));
var AngleDoubleLeft_1 = __importDefault(require("../icons/AngleDoubleLeft"));
var AngleDoubleRight_1 = __importDefault(require("../icons/AngleDoubleRight"));
/**
 * @example ./doc/pagination.md
 */
var Pagination = /** @class */ (function (_super) {
    __extends(Pagination, _super);
    function Pagination() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.token = '';
        _this.inferredSmall = true;
        _this.getIconsProps = function (prefixCls, direction) {
            var prevIcon = (react_1.default.createElement("a", { className: prefixCls + "-item-link" },
                react_1.default.createElement(AngleLeft_1.default, null)));
            var nextIcon = (react_1.default.createElement("a", { className: prefixCls + "-item-link" },
                react_1.default.createElement(AngleRight_1.default, null)));
            var jumpPrevIcon = (react_1.default.createElement("a", { className: prefixCls + "-item-link" },
                react_1.default.createElement("div", { className: prefixCls + "-item-container" },
                    react_1.default.createElement(AngleDoubleLeft_1.default, { className: prefixCls + "-item-link-icon" }),
                    react_1.default.createElement("span", { className: prefixCls + "-item-ellipsis" }, "\u2022\u2022\u2022"))));
            var jumpNextIcon = (react_1.default.createElement("a", { className: prefixCls + "-item-link" },
                react_1.default.createElement("div", { className: prefixCls + "-item-container" },
                    react_1.default.createElement(AngleDoubleRight_1.default, { className: prefixCls + "-item-link-icon" }),
                    react_1.default.createElement("span", { className: prefixCls + "-item-ellipsis" }, "\u2022\u2022\u2022"))));
            // change arrows direction in right-to-left direction
            if (direction === 'rtl') {
                var temp = void 0;
                temp = prevIcon;
                prevIcon = nextIcon;
                nextIcon = temp;
                temp = jumpPrevIcon;
                jumpPrevIcon = jumpNextIcon;
                jumpNextIcon = temp;
            }
            return {
                prevIcon: prevIcon,
                nextIcon: nextIcon,
                jumpPrevIcon: jumpPrevIcon,
                jumpNextIcon: jumpNextIcon,
            };
        };
        _this.renderPagination = function () {
            var _a = _this.props, customizePrefixCls = _a.prefixCls, customizeSelectPrefixCls = _a.selectPrefixCls, className = _a.className, showTitle = _a.showTitle, 
            // size,
            restProps = __rest(_a, ["prefixCls", "selectPrefixCls", "className", "showTitle"]);
            // const isSmall = !(size === 'big') || this.inferredSmall;
            return (react_1.default.createElement(config_context_1.ConfigConsumer, null, function (_a) {
                var _b;
                var getPrefixCls = _a.getPrefixCls, direction = _a.direction;
                var prefixCls = getPrefixCls('pagination', customizePrefixCls);
                var selectPrefixCls = getPrefixCls('select', customizeSelectPrefixCls);
                var extendedClassName = classnames_1.default(className, (_b = {
                        mini: true
                    },
                    _b[prefixCls + "-rtl"] = direction === 'rtl',
                    _b));
                return (react_1.default.createElement(rc_pagination_1.default, __assign({}, restProps, { prefixCls: prefixCls, selectPrefixCls: selectPrefixCls }, _this.getIconsProps(prefixCls, direction), { className: extendedClassName, selectComponentClass: miniSelect_1.default, showTitle: showTitle || false })));
            }));
        };
        return _this;
    }
    Pagination.prototype.componentDidMount = function () {
        var _this = this;
        this.token = responsiveObserve_1.default.subscribe(function (screens) {
            var xs = screens.xs;
            var _a = _this.props, size = _a.size, responsive = _a.responsive;
            var inferredSmall = !!(xs && !size && responsive);
            if (_this.inferredSmall !== inferredSmall) {
                _this.inferredSmall = inferredSmall;
                _this.forceUpdate();
            }
        });
    };
    Pagination.prototype.componentWillUnmount = function () {
        responsiveObserve_1.default.unsubscribe(this.token);
    };
    Pagination.prototype.render = function () {
        return (react_1.default.createElement("div", null, this.renderPagination()));
    };
    return Pagination;
}(react_1.default.Component));
exports.default = Pagination;
//# sourceMappingURL=pagination.js.map