"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var PropTypes = __importStar(require("prop-types"));
var rc_checkbox_1 = __importDefault(require("rc-checkbox"));
var classnames_1 = __importDefault(require("classnames"));
var shallowequal_1 = __importDefault(require("shallowequal"));
var config_context_1 = require("../config-context");
var Radio = /** @class */ (function (_super) {
    __extends(Radio, _super);
    function Radio() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.saveCheckbox = function (node) {
            _this.rcCheckbox = node;
        };
        _this.onChange = function (e) {
            if (_this.props.onChange) {
                _this.props.onChange(e);
            }
            if (_this.context.radioGroup && _this.context.radioGroup.onChange) {
                _this.context.radioGroup.onChange(e);
            }
        };
        _this.renderRadio = function (_a) {
            var _b;
            var getPrefixCls = _a.getPrefixCls;
            var _c = _this, props = _c.props, context = _c.context;
            var customizePrefixCls = props.prefixCls, className = props.className, children = props.children, style = props.style, restProps = __rest(props, ["prefixCls", "className", "children", "style"]);
            var radioGroup = context.radioGroup;
            var prefixCls = getPrefixCls('radio', customizePrefixCls);
            var radioProps = __assign({}, restProps);
            if (radioGroup) {
                radioProps.name = radioGroup.name;
                radioProps.onChange = _this.onChange;
                radioProps.checked = props.value === radioGroup.value;
                radioProps.disabled = props.disabled || radioGroup.disabled;
            }
            var wrapperClassString = classnames_1.default(className, (_b = {},
                _b[prefixCls + "-wrapper"] = true,
                _b[prefixCls + "-wrapper-checked"] = radioProps.checked,
                _b[prefixCls + "-wrapper-disabled"] = radioProps.disabled,
                _b));
            return (
            // eslint-disable-next-line jsx-a11y/label-has-associated-control
            React.createElement("label", { className: wrapperClassString, style: style, onMouseEnter: props.onMouseEnter, onMouseLeave: props.onMouseLeave },
                React.createElement(rc_checkbox_1.default, __assign({}, radioProps, { prefixCls: prefixCls, ref: _this.saveCheckbox })),
                children !== undefined ? React.createElement("span", null, children) : null));
        };
        return _this;
    }
    Radio.prototype.shouldComponentUpdate = function (nextProps, nextState, nextContext) {
        return (!shallowequal_1.default(this.props, nextProps) ||
            !shallowequal_1.default(this.state, nextState) ||
            !shallowequal_1.default(this.context.radioGroup, nextContext.radioGroup));
    };
    Radio.prototype.focus = function () {
        this.rcCheckbox.focus();
    };
    Radio.prototype.blur = function () {
        this.rcCheckbox.blur();
    };
    Radio.prototype.render = function () {
        return React.createElement(config_context_1.ConfigConsumer, null, this.renderRadio);
    };
    Radio.defaultProps = {
        type: 'radio',
    };
    Radio.contextTypes = {
        radioGroup: PropTypes.any,
    };
    return Radio;
}(React.Component));
exports.default = Radio;
//# sourceMappingURL=radio.js.map