"use strict";
// TODO: 4.0 - codemod should help to change `filterOption` to support node props.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var object_omit_1 = __importDefault(require("object.omit"));
var classnames_1 = __importDefault(require("classnames"));
var rc_select_1 = __importStar(require("rc-select"));
var config_context_1 = require("../config-context");
// import getIcons from './utils/iconUtil';
var AngleDown_1 = __importDefault(require("../icons/AngleDown"));
var sizeContext_1 = __importDefault(require("../config-context/sizeContext"));
require("./style");
// We still use class here since `forwardRef` not support generic in typescript
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.selectRef = React.createRef();
        _this.focus = function () {
            if (_this.selectRef.current) {
                _this.selectRef.current.focus();
            }
        };
        _this.blur = function () {
            if (_this.selectRef.current) {
                _this.selectRef.current.blur();
            }
        };
        _this.getMode = function () {
            var mode = _this.props.mode;
            if (mode === 'combobox') {
                return undefined;
            }
            if (mode === Select.SECRET_COMBOBOX_MODE_DO_NOT_USE) {
                return 'combobox';
            }
            return mode;
        };
        _this.renderSelect = function (_a) {
            var _b;
            var getContextPopupContainer = _a.getPopupContainer, getPrefixCls = _a.getPrefixCls, renderEmpty = _a.renderEmpty, direction = _a.direction;
            var _c = _this.props, customizePrefixCls = _c.prefixCls, notFoundContent = _c.notFoundContent, className = _c.className, customizeSize = _c.size, _d = _c.listHeight, listHeight = _d === void 0 ? 256 : _d, _e = _c.listItemHeight, listItemHeight = _e === void 0 ? 32 : _e, getPopupContainer = _c.getPopupContainer, dropdownClassName = _c.dropdownClassName, bordered = _c.bordered;
            var prefixCls = getPrefixCls('select', customizePrefixCls);
            var mode = _this.getMode();
            var isMultiple = mode === 'multiple' || mode === 'tags';
            // ===================== Empty =====================
            var mergedNotFound;
            if (notFoundContent !== undefined) {
                mergedNotFound = notFoundContent;
            }
            else if (mode === 'combobox') {
                mergedNotFound = null;
            }
            else {
                mergedNotFound = renderEmpty('Select');
            }
            // ===================== Icons =====================
            // const { suffixIcon, itemIcon, removeIcon, clearIcon } = getIcons({
            //   ...this.props,
            //   multiple: isMultiple,
            // });
            // @ts-ignore
            var selectProps = object_omit_1.default(_this.props, [
                'prefixCls',
                'suffixIcon',
                'itemIcon',
                'removeIcon',
                'clearIcon',
                'size',
                'bordered',
            ]);
            var rcSelectRtlDropDownClassName = classnames_1.default(dropdownClassName, (_b = {},
                _b[prefixCls + "-dropdown-" + direction] = direction === 'rtl',
                _b));
            return (React.createElement(sizeContext_1.default.Consumer, null, function (size) {
                var _a;
                var mergedSize = customizeSize || size;
                var mergedClassName = classnames_1.default(className, (_a = {},
                    _a[prefixCls + "-lg"] = mergedSize === 'large',
                    _a[prefixCls + "-sm"] = mergedSize === 'small',
                    _a[prefixCls + "-rtl"] = direction === 'rtl',
                    _a[prefixCls + "-borderless"] = !bordered,
                    _a));
                return (React.createElement(rc_select_1.default, __assign({ ref: _this.selectRef }, selectProps, { listHeight: listHeight, listItemHeight: listItemHeight, mode: mode, prefixCls: prefixCls, direction: direction, inputIcon: AngleDown_1.default, 
                    // menuItemSelectedIcon={AngleDown}
                    //   removeIcon={removeIcon}
                    //   clearIcon={clearIcon}
                    notFoundContent: mergedNotFound, className: mergedClassName, getPopupContainer: getPopupContainer || getContextPopupContainer, dropdownClassName: rcSelectRtlDropDownClassName })));
            }));
        };
        return _this;
    }
    Select.prototype.render = function () {
        return React.createElement(config_context_1.ConfigConsumer, null, this.renderSelect);
    };
    Select.Option = rc_select_1.Option;
    Select.OptGroup = rc_select_1.OptGroup;
    Select.SECRET_COMBOBOX_MODE_DO_NOT_USE = 'SECRET_COMBOBOX_MODE_DO_NOT_USE';
    Select.defaultProps = {
        transitionName: 'slide-up',
        choiceTransitionName: 'zoom',
        bordered: true,
    };
    return Select;
}(React.Component));
exports.default = Select;
//# sourceMappingURL=index.js.map