"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var rc_table_1 = __importDefault(require("rc-table"));
var shallowequal_1 = __importDefault(require("shallowequal"));
var pagination_1 = __importDefault(require("../pagination"));
var config_context_1 = require("../config-context");
var _util_1 = require("./_util");
var SortArrowDown_1 = __importDefault(require("../icons/SortArrowDown"));
var SortArrowUp_1 = __importDefault(require("../icons/SortArrowUp"));
var SortArrowNormal_1 = __importDefault(require("../icons/SortArrowNormal"));
function getColumnKey(column, index) {
    return column.key || column.dataIndex || index;
}
function isSameColumn(a, b) {
    if (a && b && a.key && a.key === b.key) {
        return true;
    }
    return (a === b ||
        shallowequal_1.default(a, b, function (value, other) {
            // https://github.com/ant-design/ant-design/issues/12737
            if (typeof value === 'function' && typeof other === 'function') {
                return value === other || value.toString() === other.toString();
            }
            // https://github.com/ant-design/ant-design/issues/19398
            if (Array.isArray(value) && Array.isArray(other)) {
                return value === other || shallowequal_1.default(value, other);
            }
            return false;
        }));
}
function noop() { }
var defaultPagination = {
    onChange: noop,
    onShowSizeChange: noop,
};
/**
 * Avoid creating new object, so that parent component's shouldComponentUpdate
 * can works appropriately。
 */
var noPaginationObj = { total: 0 };
/**
 * @example ./doc/table.md
 */
var Table = /** @class */ (function (_super) {
    __extends(Table, _super);
    function Table(props) {
        var _this = _super.call(this, props) || this;
        _this.handlePageChange = function (current) {
            var otherArguments = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                otherArguments[_i - 1] = arguments[_i];
            }
            var props = _this.props;
            var pagination = __assign({}, _this.state.pagination);
            if (current) {
                pagination.current = current;
            }
            else {
                pagination.current = pagination.current || 1;
            }
            pagination.onChange.apply(pagination, __spreadArrays([pagination.current], otherArguments));
            var newState = {
                pagination: pagination,
            };
            // Controlled current prop will not respond user interaction
            if (props.pagination && typeof props.pagination === 'object' && 'current' in props.pagination) {
                newState.pagination = __assign(__assign({}, pagination), { current: _this.state.pagination.current });
            }
            _this.setState(newState);
            // this.setState(newState, this.scrollToFirstRow);
            // this.props.store.setState({
            //   selectionDirty: false,
            // });
            var onChange = _this.props.onChange;
            if (onChange) {
                /* eslint-disable prefer-spread */
                onChange.apply(null, _this.prepareParamsArguments(__assign(__assign({}, _this.state), { 
                    // selectionDirty: false,
                    pagination: pagination })));
            }
        };
        _this.renderTable = function (_a) {
            var _b;
            var getPrefixCls = _a.getPrefixCls, renderEmpty = _a.renderEmpty;
            var data = _this.getCurrentPageData();
            var _c = _this.props, customizePrefixCls = _c.prefixCls, className = _c.className, columns = _c.columns, size = _c.size, bordered = _c.bordered, restProps = __rest(_c, ["prefixCls", "className", "columns", "size", "bordered"]);
            var prefixCls = getPrefixCls('table', customizePrefixCls);
            var cols = _this.renderColumns({
                prefixCls: prefixCls,
                columns: columns,
            });
            var emptyText = _this.props.emptyText || renderEmpty('Table');
            return (react_1.default.createElement("div", null,
                _this.renderPagination(prefixCls, 'top'),
                react_1.default.createElement(rc_table_1.default, __assign({}, restProps, { key: "table", prefixCls: prefixCls, className: classnames_1.default(className, (_b = {},
                        _b[prefixCls + "-middle"] = size === 'middle',
                        _b[prefixCls + "-small"] = size === 'small',
                        _b[prefixCls + "-bordered"] = bordered,
                        _b)), columns: cols, data: data, emptyText: emptyText })),
                react_1.default.createElement("div", { style: { overflow: 'auto' } }, _this.renderPagination(prefixCls, 'bottom'))));
        };
        var columnsProp = props.columns;
        var columns = columnsProp || _util_1.normalizeColumns(props.children);
        _this.state = __assign(__assign({}, _this.getDefaultSortOrder(columns || [])), { pagination: _this.getDefaultPagination(props), prevProps: props, columns: columns });
        return _this;
    }
    Table.getDerivedStateFromProps = function (nextProps, prevState) {
        var prevProps = prevState.prevProps;
        var columns = nextProps.columns || _util_1.normalizeColumns(nextProps.children);
        var nextState = __assign(__assign({}, prevState), { prevProps: nextProps, columns: columns });
        if ('pagination' in nextProps || 'pagination' in prevProps) {
            var newPagination = __assign(__assign(__assign({}, defaultPagination), prevState.pagination), nextProps.pagination);
            newPagination.current = newPagination.current || 1;
            newPagination.pageSize = newPagination.pageSize || 10;
            nextState = __assign(__assign({}, nextState), { pagination: nextProps.pagination !== false ? newPagination : noPaginationObj });
        }
        return nextState;
    };
    Table.prototype.getDefaultPagination = function (props) {
        var pagination = typeof props.pagination === 'object' ? props.pagination : noPaginationObj;
        var current;
        if ('current' in pagination) {
            current = pagination.current;
        }
        else if ('defaultCurrent' in pagination) {
            current = pagination.defaultCurrent;
        }
        var pageSize;
        if ('pageSize' in pagination) {
            pageSize = pagination.pageSize;
        }
        return this.hasPagination(props)
            ? __assign(__assign(__assign({}, defaultPagination), pagination), { current: current || 1, pageSize: pageSize || 10 }) : noPaginationObj;
    };
    Table.prototype.hasPagination = function (props) {
        return (props || this.props).pagination !== false;
    };
    Table.prototype.isSortColumn = function (column) {
        var sortColumn = this.state.sortColumn;
        if (!column || !sortColumn) {
            return false;
        }
        return getColumnKey(sortColumn) === getColumnKey(column);
    };
    Table.prototype.getSortOrderColumns = function (columns) {
        return _util_1.flatFilter(columns || (this.state || {}).columns || [], function (column) { return 'sortOrder' in column; });
    };
    Table.prototype.getSortStateFromColumns = function (columns) {
        // return first column which sortOrder is not falsy
        var sortedColumn = this.getSortOrderColumns(columns).filter(function (col) { return col.sortOrder; })[0];
        if (sortedColumn) {
            return {
                sortColumn: sortedColumn,
                sortOrder: sortedColumn.sortOrder,
            };
        }
        return {
            sortColumn: null,
            sortOrder: null,
        };
    };
    Table.prototype.getDefaultSortOrder = function (columns) {
        var definedSortState = this.getSortStateFromColumns(columns);
        var defaultSortedColumn = _util_1.flatFilter(columns || [], function (column) {
            return column.defaultSortOrder != null;
        })[0];
        if (defaultSortedColumn && !definedSortState.sortColumn) {
            return {
                sortColumn: defaultSortedColumn,
                sortOrder: defaultSortedColumn.defaultSortOrder,
            };
        }
        return definedSortState;
    };
    Table.prototype.toggleSortOrder = function (column) {
        // const pagination = { ...this.state.pagination };
        var sortDirections = column.sortDirections || ['ascend', 'descend'];
        var _a = this.state, sortOrder = _a.sortOrder, sortColumn = _a.sortColumn;
        // 只同时允许一列进行排序，否则会导致排序顺序的逻辑问题
        var newSortOrder;
        // 切换另一列时，丢弃 sortOrder 的状态
        if (isSameColumn(sortColumn, column) && sortOrder !== undefined) {
            // 按照sortDirections的内容依次切换排序状态
            var methodIndex = sortDirections.indexOf(sortOrder) + 1;
            newSortOrder =
                methodIndex === sortDirections.length ? undefined : sortDirections[methodIndex];
        }
        else {
            newSortOrder = sortDirections[0];
        }
        // if (this.props.pagination) {
        //   // Reset current prop
        //   pagination.current = 1;
        //   pagination.onChange!(pagination.current);
        // }
        var newState = {
            // pagination,
            sortOrder: newSortOrder,
            sortColumn: newSortOrder ? column : null,
        };
        this.setState(newState);
        // Controlled
        // if (this.getSortOrderColumns().length === 0) {
        //   this.setState(newState, this.scrollToFirstRow);
        // }
        var onChange = this.props.onChange;
        if (onChange) {
            /* eslint-disable prefer-spread */
            onChange.apply(null, this.prepareParamsArguments(__assign(__assign({}, this.state), newState), column));
        }
    };
    Table.prototype.recursiveSort = function (data, sorterFn) {
        var _this = this;
        var _a = this.props.childrenColumnName, childrenColumnName = _a === void 0 ? 'children' : _a;
        return data.sort(sorterFn).map(function (item) {
            var _a;
            return item[childrenColumnName]
                ? __assign(__assign({}, item), (_a = {}, _a[childrenColumnName] = _this.recursiveSort(item[childrenColumnName], sorterFn), _a)) : item;
        });
    };
    Table.prototype.getSorterFn = function (state) {
        var _a = state || this.state, sortOrder = _a.sortOrder, sortColumn = _a.sortColumn;
        if (!sortOrder || !sortColumn || typeof sortColumn.sorter !== 'function') {
            return;
        }
        return function (a, b) {
            var result = sortColumn.sorter(a, b, sortOrder);
            if (result !== 0) {
                return sortOrder === 'descend' ? -result : result;
            }
            return 0;
        };
    };
    Table.prototype.getMaxPage = function (total) {
        var _a = this.state.pagination, current = _a.current, pageSize = _a.pageSize;
        if ((current - 1) * pageSize >= total) {
            return Math.floor((total - 1) / pageSize) + 1;
        }
        return current;
    };
    Table.prototype.getMaxCurrent = function (total) {
        var _a = this.state.pagination, current = _a.current, pageSize = _a.pageSize;
        if ((current - 1) * pageSize >= total) {
            return Math.floor((total - 1) / pageSize) + 1;
        }
        return current;
    };
    Table.prototype.getCurrentPageData = function () {
        var data = this.getLocalData();
        var current;
        var pageSize;
        var state = this.state;
        // 如果没有分页的话，默认全部展示
        if (!this.hasPagination()) {
            pageSize = Number.MAX_VALUE;
            current = 1;
        }
        else {
            pageSize = state.pagination.pageSize;
            current = this.getMaxPage(state.pagination.total || data.length);
        }
        // 分页
        // ---
        // 当数据量少于等于每页数量时，直接设置数据
        // 否则进行读取分页数据
        if (data.length > pageSize || pageSize === Number.MAX_VALUE) {
            data = data.slice((current - 1) * pageSize, current * pageSize);
        }
        return data;
    };
    Table.prototype.getLocalData = function (state /* , filter: boolean = true */) {
        var currentState = state || this.state;
        var dataSource = this.props.dataSource;
        var data = dataSource || [];
        // 优化本地排序
        data = data.slice(0);
        var sorterFn = this.getSorterFn(currentState);
        if (sorterFn) {
            data = this.recursiveSort(data, sorterFn);
        }
        // 筛选
        // if (filter && currentState.filters) {
        //   Object.keys(currentState.filters).forEach(columnKey => {
        //     const col = this.findColumn(columnKey) as any;
        //     if (!col) {
        //       return;
        //     }
        //     const values = currentState.filters[columnKey] || [];
        //     if (values.length === 0) {
        //       return;
        //     }
        //     const onFilter = col.onFilter;
        //     data = onFilter
        //       ? data.filter(record => {
        //           return values.some(v => onFilter(v, record));
        //         })
        //       : data;
        //   });
        // }
        return data;
    };
    // Get pagination, filters, sorter
    Table.prototype.prepareParamsArguments = function (state, column) {
        // PrepareParamsArgumentsReturn<T>
        var pagination = __assign({}, state.pagination);
        // remove useless handle function in Table.onChange
        // delete pagination.onChange;
        // delete pagination.onShowSizeChange;
        // const filters = state.filters;
        var sorter = {};
        var currentColumn = column;
        if (state.sortColumn && state.sortOrder) {
            currentColumn = state.sortColumn;
            sorter.column = state.sortColumn;
            sorter.order = state.sortOrder;
        }
        if (currentColumn) {
            sorter.field = currentColumn.dataIndex;
            sorter.columnKey = getColumnKey(currentColumn);
        }
        var extra = {
            currentDataSource: this.getLocalData(state),
        };
        return [pagination, /*  filters, */ sorter, extra];
    };
    Table.prototype.renderPagination = function (prefixCls, paginationPosition) {
        // 强制不需要分页
        if (!this.hasPagination()) {
            return null;
        }
        // let size = 'default';
        // if (this.props.size === 'small') {
        //   size = 'small';
        // }
        var pagination = this.state.pagination;
        var position = pagination.position || 'bottom';
        var total = pagination.total || this.getLocalData().length;
        return total > 0 && (position === paginationPosition || position === 'both') ? (react_1.default.createElement(pagination_1.default, __assign({ key: "pagination-" + paginationPosition }, pagination, { className: classnames_1.default(pagination.className, prefixCls + "-pagination"), onChange: this.handlePageChange, total: total, 
            // size={size}
            current: this.getMaxCurrent(total) }))) : null;
    };
    Table.prototype.renderColumnTitle = function (title) {
        var _a = this.state, sortOrder = _a.sortOrder, sortColumn = _a.sortColumn;
        if (title instanceof Function) {
            return title({
                sortOrder: sortOrder,
                sortColumn: sortColumn,
            });
        }
        return title;
    };
    Table.prototype.renderColumns = function (_a) {
        var _this = this;
        var prefixCls = _a.prefixCls, columns = _a.columns;
        var _b = this.state, sortOrder = _b.sortOrder, sortColumn = _b.sortColumn;
        return _util_1.treeMap(columns, function (column /* , i: number */) {
            var _a;
            // const key = getColumnKey(column, i) as string;
            var sortButton;
            var isSortColumn = _this.isSortColumn(column);
            var onHeaderCell = column.onHeaderCell;
            if (column.sorter) {
                // const sortDirections = column.sortDirections || (this.props.sortDirections as SortOrder[]);
                var isAscend = isSortColumn && sortOrder === 'ascend';
                // const isDescend = isSortColumn && sortOrder === 'descend';
                var isNormal = !isSameColumn(column, sortColumn) || !sortOrder;
                var renderedIcon = void 0;
                if (isNormal)
                    renderedIcon = react_1.default.createElement(SortArrowNormal_1.default, null);
                else
                    renderedIcon = isAscend ? react_1.default.createElement(SortArrowDown_1.default, null) : react_1.default.createElement(SortArrowUp_1.default, null);
                sortButton = (react_1.default.createElement("div", { title: 'sort button title', className: classnames_1.default(prefixCls + "-column-sorter-inner", isNormal && prefixCls + "-column-sorter-inner-normal"), key: "sorter" }, renderedIcon));
                onHeaderCell = function (col) {
                    var colProps = {};
                    // Get original first
                    if (column.onHeaderCell) {
                        colProps = __assign({}, column.onHeaderCell(col));
                    }
                    // Add sorter logic
                    var onHeaderCellClick = colProps.onClick;
                    colProps.onClick = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        _this.toggleSortOrder(column);
                        if (onHeaderCellClick) {
                            onHeaderCellClick.apply(void 0, args);
                        }
                    };
                    return colProps;
                };
                return __assign(__assign({}, column), { className: classnames_1.default(column.className, (_a = {},
                        _a[prefixCls + "-column-has-actions"] = sortButton || '',
                        _a[prefixCls + "-column-has-sorters"] = sortButton,
                        _a[prefixCls + "-column-sort"] = isSortColumn && sortOrder,
                        _a)), title: (react_1.default.createElement("span", { key: "title", className: prefixCls + "-header-column" },
                        react_1.default.createElement("div", { className: sortButton ? prefixCls + "-column-sorters" : undefined },
                            react_1.default.createElement("span", { className: prefixCls + "-column-title" }, _this.renderColumnTitle(column.title)),
                            react_1.default.createElement("span", { className: prefixCls + "-column-sorter" }, sortButton)))), onHeaderCell: onHeaderCell });
            }
            return column;
        });
    };
    Table.prototype.render = function () {
        return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderTable);
    };
    Table.defaultProps = {
        rowKey: 'key',
    };
    return Table;
}(react_1.default.Component));
exports.default = Table;
//# sourceMappingURL=Table.js.map