"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
function treeMap(tree, mapper, childrenName) {
    if (childrenName === void 0) { childrenName = 'children'; }
    return tree.map(function (node, index) {
        var extra = {};
        if (node[childrenName]) {
            extra[childrenName] = treeMap(node[childrenName], mapper, childrenName);
        }
        return __assign(__assign({}, mapper(node, index)), extra);
    });
}
exports.treeMap = treeMap;
function flatFilter(tree, callback) {
    return tree.reduce(function (acc, node) {
        if (callback(node)) {
            acc.push(node);
        }
        if (node.children) {
            var children = flatFilter(node.children, callback);
            acc.push.apply(acc, children);
        }
        return acc;
    }, []);
}
exports.flatFilter = flatFilter;
function normalizeColumns(elements) {
    var columns = [];
    react_1.default.Children.forEach(elements, function (element) {
        if (!react_1.default.isValidElement(element)) {
            return;
        }
        var column = __assign({}, element.props);
        if (element.key) {
            column.key = element.key;
        }
        if (element.type && element.type.__ANT_TABLE_COLUMN_GROUP) {
            column.children = normalizeColumns(column.children);
        }
        columns.push(column);
    });
    return columns;
}
exports.normalizeColumns = normalizeColumns;
//# sourceMappingURL=_util.js.map