import React from 'react';
import { BaseProps } from '../_base/interface';
import { ConfigConsumerProps } from '../config-context';
import { TabObj } from './Tab';
import { Option } from '../dropdown';
import './style/index.scss';
export interface TabsProps extends BaseProps {
    defaultActiveKey?: number;
    tabs: TabObj[];
    selected: number;
    operations?: Operation[];
    onSelect?: (selectedTabIndex: number | string, item?: TabObj, e?: React.MouseEvent) => any;
    add?: (isOverflowed: boolean) => any;
    remove?: (previousAvailableKey: number, isOverflowed: boolean) => any;
}
export interface TabsState {
    visibleTabs: number[];
    hiddenTabs: number[];
    tabWidths: number[];
    showMoreBtnWidth: number;
    containerWidth: number;
}
export declare type Operation = 'add' | 'remove';
declare class Tabs extends React.Component<TabsProps, TabsState> {
    state: TabsState;
    static defaultProps: {
        selected: number;
    };
    tabsWrapRef: React.RefObject<HTMLDivElement>;
    tabsContainerRef: React.RefObject<HTMLDivElement>;
    tabOperationsRef: React.RefObject<HTMLDivElement>;
    static getDerivedStateFromProps(nextProps: TabsProps, prevState: TabsState): {
        visibleTabs: number[];
        hiddenTabs: number[];
        selected: number;
    };
    handleClick: (item: TabObj, currentIndex: number, e: React.MouseEvent<Element, MouseEvent>) => void;
    handleClickDropdownTab: (option: Option) => void;
    handleClickOption: (val: string) => void;
    add: () => void;
    remove: () => void;
    getPreviousAvailableKey: () => number;
    rename: () => void;
    checkIfTabsOverflowed: () => boolean;
    private handleMeasurement;
    renderTabs(prefixCls: string): JSX.Element;
    renderTabsDropdown(prefixCls: string): JSX.Element;
    renderOperations(prefixCls: string): JSX.Element;
    renderTabWrapper: ({ getPrefixCls }: ConfigConsumerProps) => JSX.Element;
    render(): JSX.Element;
}
export default Tabs;
