"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var config_context_1 = require("../config-context");
var Tab_1 = __importDefault(require("./Tab"));
var dropdown_1 = __importDefault(require("../dropdown"));
var Cog_1 = __importDefault(require("../icons/Cog"));
var EllipsisH_1 = __importDefault(require("../icons/EllipsisH"));
var utilities_1 = __importDefault(require("./utilities"));
var tabMeasure_1 = __importDefault(require("./tabMeasure"));
require("./style/index.scss");
var OperationNames = {
    // rename: '重命名',
    add: '添加',
    remove: '删除',
};
var OPERATIONS = {
    // RENAME: 'rename',
    ADD: 'add',
    REMOVE: 'remove',
};
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            visibleTabs: [],
            hiddenTabs: [],
            tabWidths: [],
            showMoreBtnWidth: 0,
            containerWidth: Infinity,
        };
        _this.tabsWrapRef = react_1.default.createRef();
        _this.tabsContainerRef = react_1.default.createRef();
        _this.tabOperationsRef = react_1.default.createRef();
        _this.handleClick = function (item, currentIndex, e) {
            var onSelect = _this.props.onSelect;
            if (item.disabled)
                return;
            var _a = item.key, key = _a === void 0 ? currentIndex : _a;
            if (onSelect)
                onSelect(key, item, e);
        };
        _this.handleClickDropdownTab = function (option) {
            var _a = _this.props, onSelect = _a.onSelect, tabs = _a.tabs;
            var tabIndex = -1;
            for (var i = 0; i < tabs.length; i++) {
                if (tabs[i].label === option.label) {
                    tabIndex = i;
                    break;
                }
            }
            if (onSelect)
                onSelect(tabIndex, tabs[tabIndex]);
        };
        _this.handleClickOption = function (val) {
            switch (val) {
                // case OPERATIONS.RENAME:
                //   this.rename();
                //   return;
                case OPERATIONS.REMOVE:
                    _this.remove();
                    return;
                case OPERATIONS.ADD:
                    _this.add();
                // eslint-disable-next-line no-fallthrough
                default:
                    break;
            }
        };
        _this.add = function () {
            var add = _this.props.add;
            if (add)
                add(_this.checkIfTabsOverflowed());
        };
        _this.remove = function () {
            var remove = _this.props.remove;
            if (remove)
                remove(_this.getPreviousAvailableKey(), _this.checkIfTabsOverflowed());
        };
        _this.getPreviousAvailableKey = function () {
            var _a = _this.props, selected = _a.selected, tabs = _a.tabs;
            if (selected === -1)
                return selected;
            var key = selected;
            key -= 1;
            while (key > -1 && tabs[key].disabled) {
                key--;
            }
            return key;
        };
        _this.rename = function () { };
        _this.checkIfTabsOverflowed = function () {
            var tabs = _this.props.tabs;
            var visibleTabs = _this.state.visibleTabs;
            return visibleTabs.length < tabs.length;
        };
        _this.handleMeasurement = function (measurements) {
            var _a = _this.props, selected = _a.selected, tabs = _a.tabs;
            var tabWidths = measurements.hiddenTabWidths, containerWidth = measurements.containerWidth, showMoreBtnWidth = measurements.showMoreBtnWidth;
            var _b = utilities_1.default(tabs, selected, showMoreBtnWidth, tabWidths, containerWidth), visibleTabs = _b.visibleTabs, hiddenTabs = _b.hiddenTabs;
            _this.setState({
                visibleTabs: visibleTabs,
                hiddenTabs: hiddenTabs,
                showMoreBtnWidth: showMoreBtnWidth,
                containerWidth: containerWidth,
                tabWidths: tabWidths,
            });
        };
        _this.renderTabWrapper = function (_a) {
            var getPrefixCls = _a.getPrefixCls;
            var _b = _this.props, customizePrefixCls = _b.prefixCls, operations = _b.operations;
            var prefixCls = getPrefixCls('tabs', customizePrefixCls);
            return (react_1.default.createElement("div", { className: prefixCls },
                react_1.default.createElement("div", { ref: _this.tabsWrapRef, className: prefixCls + "-wrap" },
                    _this.renderTabs(prefixCls),
                    operations && operations.length && _this.renderOperations(prefixCls))));
        };
        return _this;
    }
    Tabs.getDerivedStateFromProps = function (nextProps, prevState) {
        var showMoreBtnWidth = prevState.showMoreBtnWidth, tabWidths = prevState.tabWidths, containerWidth = prevState.containerWidth;
        var _a = utilities_1.default(nextProps.tabs, nextProps.selected, showMoreBtnWidth, tabWidths, containerWidth), visibleTabs = _a.visibleTabs, hiddenTabs = _a.hiddenTabs;
        return {
            visibleTabs: visibleTabs,
            hiddenTabs: hiddenTabs,
            selected: nextProps.selected,
        };
    };
    Tabs.prototype.renderTabs = function (prefixCls) {
        var _this = this;
        var visibleTabs = this.state.visibleTabs;
        var _a = this.props, tabs = _a.tabs, selected = _a.selected;
        var isTabsDropdownVisible = this.checkIfTabsOverflowed();
        return (react_1.default.createElement("div", { className: prefixCls + "-inner-wrap" },
            react_1.default.createElement("div", { className: prefixCls + "-con " + (isTabsDropdownVisible ? 'fill-space' : ''), ref: this.tabsContainerRef },
                visibleTabs
                    .sort(function (tabA, tabB) { return tabA - tabB; })
                    .map(function (tabIndex) {
                    var tab = tabs[tabIndex];
                    var isSelected = (tab.key || tabIndex) === selected;
                    return (react_1.default.createElement(Tab_1.default, { isSelect: isSelected, onClick: function (e) { return _this.handleClick(tab, tabIndex, e); }, key: tab.key || tab.title, title: tab.title, prefixCls: prefixCls, label: tab.label, value: tab.value, disabled: tab.disabled }));
                }),
                this.renderTabsDropdown(prefixCls)),
            react_1.default.createElement(tabMeasure_1.default, { selected: selected, prefixCls: prefixCls, tabs: tabs, handleMeasurement: this.handleMeasurement })));
    };
    Tabs.prototype.renderTabsDropdown = function (prefixCls) {
        var hiddenTabs = this.state.hiddenTabs;
        var tabs = this.props.tabs;
        var isTabsDropdownVisible = this.checkIfTabsOverflowed();
        var options = hiddenTabs
            .sort(function (paneA, paneB) { return paneA - paneB; })
            .map(function (paneIndex) { return tabs[paneIndex]; });
        return (react_1.default.createElement("div", { className: prefixCls + "-more " + (isTabsDropdownVisible ? 'visible' : '') },
            react_1.default.createElement(dropdown_1.default, { options: options, trigger: "click", overlayClassName: prefixCls + "-more-tabs-dropdown", placement: "bottomRight", openClassName: prefixCls + "-more-open", onSelect: this.handleClickDropdownTab },
                react_1.default.createElement(EllipsisH_1.default, { className: prefixCls + "-more-icon" }))));
    };
    Tabs.prototype.renderOperations = function (prefixCls) {
        var _this = this;
        var menuItem = function (_a) {
            var item = _a.item;
            return (
            // eslint-disable-next-line jsx-a11y/click-events-have-key-events
            react_1.default.createElement("div", { className: prefixCls + "-operation-opt", onClick: function () { return _this.handleClickOption(item.value); } }, item.label));
        };
        var operations = this.props.operations;
        var opts = operations.map(function (opt) { return ({
            label: OperationNames[opt],
            value: opt,
            className: "opt-" + opt,
        }); });
        return (react_1.default.createElement("div", { className: prefixCls + "-operation-wrap", ref: this.tabOperationsRef },
            react_1.default.createElement("span", { className: prefixCls + "-operation-divider" }),
            react_1.default.createElement(dropdown_1.default, { overlayClassName: prefixCls + "-operation-options", placement: "bottomRight", openClassName: prefixCls + "-operation-open", trigger: "click", options: opts, MenuItem: menuItem },
                react_1.default.createElement("div", { className: prefixCls + "-operation" },
                    react_1.default.createElement(Cog_1.default, { className: prefixCls + "-operation-icon" }),
                    "\u64CD\u4F5C"))));
    };
    Tabs.prototype.render = function () {
        return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderTabWrapper);
    };
    Tabs.defaultProps = {
        selected: 0,
    };
    return Tabs;
}(react_1.default.Component));
exports.default = Tabs;
//# sourceMappingURL=index.js.map