"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getVisibleAndHiddenTabIndices(tabs, selected, showMoreBtnWidth, tabWidths, containerWidth) {
    if (showMoreBtnWidth === void 0) { showMoreBtnWidth = 50; }
    var sumTabWidths = tabWidths.reduce(function (sum, width) { return sum + width; }, 0);
    var arrayOfTabIndices = tabs.map(function (_, index) {
        return index;
    });
    var visibleTabs = [];
    var hiddenTabs = [];
    if (containerWidth > sumTabWidths) {
        visibleTabs.push.apply(visibleTabs, arrayOfTabIndices);
    }
    else {
        var tabListWidth_1 = 0;
        // deal with the situation that removing the first tab will let selected be -1
        if (selected !== -1) {
            visibleTabs.push(selected);
            tabListWidth_1 = tabWidths[selected];
        }
        arrayOfTabIndices.forEach(function (currentTabIndex) {
            if (currentTabIndex !== selected) {
                var currentTabWidth = tabWidths[currentTabIndex];
                if (tabListWidth_1 + currentTabWidth > containerWidth - showMoreBtnWidth) {
                    hiddenTabs.push(currentTabIndex);
                    return;
                }
                visibleTabs.push(currentTabIndex);
                tabListWidth_1 += currentTabWidth;
            }
        });
    }
    return {
        visibleTabs: visibleTabs,
        hiddenTabs: hiddenTabs,
    };
}
exports.default = getVisibleAndHiddenTabIndices;
//# sourceMappingURL=utilities.js.map